diff --git a/arch/arm/boot/dts/am335x-boneblack.dts b/arch/arm/boot/dts/am335x-boneblack.dts
index eadbba3..346f529 100644
--- a/arch/arm/boot/dts/am335x-boneblack.dts
+++ b/arch/arm/boot/dts/am335x-boneblack.dts
@@ -36,32 +36,32 @@
 &am33xx_pinmux {
 	nxp_hdmi_bonelt_pins: nxp_hdmi_bonelt_pins {
 		pinctrl-single,pins = <
-			0x1b0 0x03      /* xdma_event_intr0, OMAP_MUX_MODE3 | AM33XX_PIN_OUTPUT */
-			0xa0 0x08       /* lcd_data0.lcd_data0, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT | AM33XX_PULL_DISA */
-			0xa4 0x08       /* lcd_data1.lcd_data1, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT | AM33XX_PULL_DISA */
-			0xa8 0x08       /* lcd_data2.lcd_data2, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT | AM33XX_PULL_DISA */
-			0xac 0x08       /* lcd_data3.lcd_data3, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT | AM33XX_PULL_DISA */
-			0xb0 0x08       /* lcd_data4.lcd_data4, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT | AM33XX_PULL_DISA */
-			0xb4 0x08       /* lcd_data5.lcd_data5, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT | AM33XX_PULL_DISA */
-			0xb8 0x08       /* lcd_data6.lcd_data6, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT | AM33XX_PULL_DISA */
-			0xbc 0x08       /* lcd_data7.lcd_data7, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT | AM33XX_PULL_DISA */
-			0xc0 0x08       /* lcd_data8.lcd_data8, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT | AM33XX_PULL_DISA */
-			0xc4 0x08       /* lcd_data9.lcd_data9, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT | AM33XX_PULL_DISA */
-			0xc8 0x08       /* lcd_data10.lcd_data10, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT | AM33XX_PULL_DISA */
-			0xcc 0x08       /* lcd_data11.lcd_data11, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT | AM33XX_PULL_DISA */
-			0xd0 0x08       /* lcd_data12.lcd_data12, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT | AM33XX_PULL_DISA */
-			0xd4 0x08       /* lcd_data13.lcd_data13, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT | AM33XX_PULL_DISA */
-			0xd8 0x08       /* lcd_data14.lcd_data14, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT | AM33XX_PULL_DISA */
-			0xdc 0x08       /* lcd_data15.lcd_data15, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT | AM33XX_PULL_DISA */
-			0xe0 0x00       /* lcd_vsync.lcd_vsync, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT */
-			0xe4 0x00       /* lcd_hsync.lcd_hsync, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT */
-			0xe8 0x00       /* lcd_pclk.lcd_pclk, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT */
-			0xec 0x00       /* lcd_ac_bias_en.lcd_ac_bias_en, OMAP_MUX_MODE0 | AM33XX_PIN_OUTPUT */
+			AM33XX_IOPAD(0x9b0, (PIN_OUTPUT_PULLDOWN | MUX_MODE3))	/* xdma_event_intr0 */
+			AM33XX_IOPAD(0x8a0, (PIN_OUTPUT | MUX_MODE0))		/* lcd_data0.lcd_data0 */
+			AM33XX_IOPAD(0x8a4, (PIN_OUTPUT | MUX_MODE0))		/* lcd_data1.lcd_data1 */
+			AM33XX_IOPAD(0x8a8, (PIN_OUTPUT | MUX_MODE0))		/* lcd_data2.lcd_data2 */
+			AM33XX_IOPAD(0x8ac, (PIN_OUTPUT | MUX_MODE0))		/* lcd_data3.lcd_data3 */
+			AM33XX_IOPAD(0x8b0, (PIN_OUTPUT | MUX_MODE0))		/* lcd_data4.lcd_data4 */
+			AM33XX_IOPAD(0x8b4, (PIN_OUTPUT | MUX_MODE0))		/* lcd_data5.lcd_data5 */
+			AM33XX_IOPAD(0x8b8, (PIN_OUTPUT | MUX_MODE0))		/* lcd_data6.lcd_data6 */
+			AM33XX_IOPAD(0x8bc, (PIN_OUTPUT | MUX_MODE0))		/* lcd_data7.lcd_data7 */
+			AM33XX_IOPAD(0x8c0, (PIN_OUTPUT | MUX_MODE0))		/* lcd_data8.lcd_data8 */
+			AM33XX_IOPAD(0x8c4, (PIN_OUTPUT | MUX_MODE0))		/* lcd_data9.lcd_data9 */
+			AM33XX_IOPAD(0x8c8, (PIN_OUTPUT | MUX_MODE0))		/* lcd_data10.lcd_data10 */
+			AM33XX_IOPAD(0x8cc, (PIN_OUTPUT | MUX_MODE0))		/* lcd_data11.lcd_data11 */
+			AM33XX_IOPAD(0x8d0, (PIN_OUTPUT | MUX_MODE0))		/* lcd_data12.lcd_data12 */
+			AM33XX_IOPAD(0x8d4, (PIN_OUTPUT | MUX_MODE0))		/* lcd_data13.lcd_data13 */
+			AM33XX_IOPAD(0x8d8, (PIN_OUTPUT | MUX_MODE0))		/* lcd_data14.lcd_data14 */
+			AM33XX_IOPAD(0x8dc, (PIN_OUTPUT | MUX_MODE0))		/* lcd_data15.lcd_data15 */
+			AM33XX_IOPAD(0x8e0, (PIN_OUTPUT_PULLDOWN | MUX_MODE0))	/* lcd_vsync.lcd_vsync */
+			AM33XX_IOPAD(0x8e4, (PIN_OUTPUT_PULLDOWN | MUX_MODE0))	/* lcd_hsync.lcd_hsync */
+			AM33XX_IOPAD(0x8e8, (PIN_OUTPUT_PULLDOWN | MUX_MODE0))	/* lcd_pclk.lcd_pclk */
+			AM33XX_IOPAD(0x8ec, (PIN_OUTPUT_PULLDOWN | MUX_MODE0))	/* lcd_ac_bias_en.lcd_ac_bias_en */
 		>;
 	};
 	nxp_hdmi_bonelt_off_pins: nxp_hdmi_bonelt_off_pins {
 		pinctrl-single,pins = <
-			0x1b0 0x03      /* xdma_event_intr0, OMAP_MUX_MODE3 | AM33XX_PIN_OUTPUT */
+			AM33XX_IOPAD(0x9b0, (PIN_OUTPUT_PULLDOWN | MUX_MODE3))	/* xdma_event_intr0 */
 		>;
 	};
 };